# MSDOS MAKE startup file.  Customize to suit your needs.
# Assumes MKS toolkit for the tool commands, and Microsoft C.  Change as req'd.
# See the documentation for a description of internally defined macros.
#
# Disable warnings for macros redefined here that were given
# on the command line.
__.SILENT := $(.SILENT)
.SILENT   := yes

# Configuration parameters for MAKE startup.mk file
# Set these to NON-NULL if you wish to turn the parameter on.
_HAVE_RCS	:=		# yes => RCS  is installed.
_HAVE_SCCS	:= 		# yes => SCCS is installed.

# Applicable suffix definitions
A := .lib	# Libraries
C := .c		# C source
E := .exe	# Executables
F := .for	# Fortran
O := .obj	# Objects
P := .pas	# Pascal
S := .asm	# Assembler sources
V := 		# RCS suffix

# See if these are defined
TMPDIR := $(TMP)
.IMPORT .IGNORE : TMPDIR SHELL COMSPEC KERNEL SWITCHAR

# Recipe execution configurations
# First set SHELL, If it is not defined, use COMSPEC, otherwise
# it is assumed to be MKS Korn SHELL.
# .IF $(SHELL) == $(NULL)
# .IF $(COMSPEC) == $(NULL)
#    SHELL := $(ROOTDIR)/bin/ksh$E
# .ELSE
#    SHELL := $(COMSPEC)
# .END
# .END
.IF $(KERNEL) == $(NULL)
SHELL := c:/os2/cmd.exe
.ELSE
.IF $(KERNEL) == DOS
SHELL := c:/dos/command.com
.ELSE
SHELL := c:/os2/command.com
.END
.END
GROUPSHELL := $(SHELL)

# Now set remaining arguments depending on which SHELL we
# are going to use.  COMSPEC (assumed to be command.com) or
# MKS Korn Shell.
.IF $(KERNEL) == $(NULL)
SHELLFLAGS  := /c
GROUPFLAGS  := $(SHELLFLAGS)
SHELLMETAS  := *"?<>|
GROUPSUFFIX := .cmd
.ELSE
.IF $(SHELL) == c:/bin/ksh.exe
SHELLFLAGS  := -c
GROUPFLAGS  := 
SHELLMETAS  := *"?<>|()&][$$\#`'
GROUPSUFFIX := .ksh
.ELSE
SHELLFLAGS  := /c
GROUPFLAGS  := $(SHELLFLAGS)
SHELLMETAS  := *"?<>|
GROUPSUFFIX := .bat
.END
.END

# Standard C-language command names and flags
   CC      := cc		# C-compiler and flags
   CFLAGS  := -qc

   AS      := masm		# Assembler and flags
   ASFLAGS := -mx -t

   LD      := link		# Loader and flags
   LDFLAGS := /noi
   LDLIBS  :=

# Definition of $(MAKE) macro for recursive makes.
   MAKE = $(MAKECMD) $(MFLAGS)

# Language and Parser generation Tools and their flags
   YACC	  := yacc		# standard yacc
   YFLAGS :=
   YTAB	  := ytab		# yacc output files name stem.

   LEX	  := lex		# standard lex
   LFLAGS :=
   LEXYY  := lexyy		# lex output file

# Other Compilers, Tools and their flags
   PC	:=		# pascal compiler
   RC	:=		# ratfor compiler
   FC	:= f77			# fortran compiler
   BC	:= bc			# basic compiler

   CO	   := co		# check out for RCS
   COFLAGS := -q

   AR     := ar			# archiver
   ARFLAGS:= ruv

   RM	   := rm		# remove a file command
   RMFLAGS :=

# Implicit generation rules for making inferences.
# We don't provide .yr or .ye rules here.  They're obsolete.
# Rules for making *$O
   %$O : %$C ; $(CC) -o $@ $(CFLAGS) -c $<
   %$O : %$P ; $(PC) -o $@ $(PFLAGS) -c $<
   %$O : %$S ; $(AS) -o $@ $<
   %$O : %.cl ; class -c $<
   %$O : %.e %.r %.F %$F ; $(FC) $(RFLAGS) $(EFLAGS) $(FFLAGS) -c $<

# Executables
   %$E : %$O ;
	$(LD) $(LDFLAGS) @<+$(<:t"+\n":s,/,\,),\
	\n$(@:s,/,\,),\nnul,\n$(LDLIBS),\n+>;

# lex and yacc rules
   %.c : %.y ; $(YACC)  $(YFLAGS) $<; mv $(YTAB).c $@
   %.c : %.l ; $(LEX)   $(LFLAGS) $<; mv $(LEXYY).c $@

# RCS support
.IF $(_HAVE_RCS)
   % : $$(@:d)RCS/$$(@:f)$V;- $(CO) $(COFLAGS) $@
   .NOINFER : $$(@:d)RCS/$$(@:f)$V
.END

# SCCS support
.IF $(_HAVE_SCCS)
   % : s.% ; get $@
   .NOINFER : s.%
.END

# Recipe to make archive files.
%$A :
[
   $(AR) $(ARFLAGS) $@ $?
   $(RM) $(RMFLAGS) $?
]

# MAKE uses this recipe to remove intermediate targets
.REMOVE :; $(RM) -f $<

# AUGMAKE extensions for SYSV compatibility
@B = $(@:b)
@D = $(@:d)
@F = $(@:f)
*B = $(*:b)
*D = $(*:d)
*F = $(*:f)
<B = $(<:b)
<D = $(<:d)
<F = $(<:f)
?B = $(?:b)
?F = $(?:f)
?D = $(?:d)

# Turn warnings back to previous setting.
.SILENT := $(__.SILENT)

# Local init file if any, gets parsed before user makefile
# .INCLUDE .IGNORE: "_startup.mk"
